exec("./overrides.cs");
exec("./RTBPrefs.cs");

function serverCmdTeam(%c, %command, %name)
{
	switch$(%command)
	{
		case "create":
		if($Pref::TeamMod::Enabled == 1)
		{
			createTeam(%c, %name);
		}
			
		case "leave":
		leaveTeam(%c);
			
		case "disband":
		disbandTeam(%c);
			
		case "invite":
		if($Pref::TeamMod::Enabled == 1)
		{
			inviteToTeam(%c, %name);
		}
			
		case "accept":
		if($Pref::TeamMod::Enabled == 1)
		{
			acceptTeamInvite(%c);
		}
			
		case "reject":
		rejectTeamInvite(%c);			
			
		case "join":
		if($Pref::TeamMod::Enabled == 1)
		{
			joinTeam(%c, %name);
		}
			
		case "kick":
		removeFromTeam(%c, %name);
			
		case "ban":
		banFromTeam(%c, %name);
			
		case "unban":
		unbanFromTeam(%c, %name);
			
		case "block":
		blockTeamInvite(%c);
			
		case "unblock":
		unblockTeamInvites(%c, %name);
			
		case "help":
		teamModHelp(%c);
	}
}

function createTeam(%c, %name)
{
	if($TeamMod::Team[%name] $= "")
	{
		if(!%c.hasTeam)
		{
			$TeamMod::Team[%name] = %name;
			$TeamMod::TeamCount[%name] = 1;
			$TeamMod::TeamOwner[%name] = %c;
			
			messageAll('', "\c3" @ %c.name SPC "\c6created team \"\c3" @ strReplace(%name,"[SPC]"," ") @ "\c6\"");
			
			%c.hasTeam = 1;
			
			%c.team = %name;
		}
		else
		{
			messageClient(%c, '', "\c6You already have a team");
		}
	}
	else
	{
		messageClient(%c, '', "\c6A team with that name already exists");
	}
}

function leaveTeam(%c)
{
	if(%c.hasTeam && %c.team !$= "")
	{
		%name = %c.team;
		
		if($TeamMod::TeamOwner[%name] == %c)
		{
			disbandTeam(%c);
		}
		else
		{
			%clientCount = clientGroup.getCount();
				
			for(%i = 0; %i < %clientCount; %i++)
			{
				%client = clientGroup.getObject(%i);
				
				if(%client.team $= %name && %client != %c)
				{
					messageClient(%client, '', "\c3" @ %c.name SPC "\c6has left the team");
				}
			}
			$TeamMod::TeamCount[%name]--;
			
			%c.hasTeam = 0;
			%c.team = "";
		}
	}
}

function disbandTeam(%c)
{
	if(%c.hasTeam && %c.team !$= "")
	{
		%name = %c.team;
		
		if($TeamMod::TeamOwner[%name] == %c)
		{
			%clientCount = clientGroup.getCount();
			
			for(%i = 0; %i < %clientCount; %i++)
			{
				%client = clientGroup.getObject(%i);
				
				%count = %client.banCount;
	
				while(%count > 0)
				{
					if(%client.bannedFromTeam[%count] $= %name)
					{
						%client.bannedFromTeam[%count] = "";
					}
					%count--;
				}
				
				if(%client.team $= %name)
				{
					%client.hasTeam = 0;
					%client.team = "";
				}
			}
			%c.hasTeam = 0;
			%c.team = "";
		
			$TeamMod::Team[%name] = "";
			$TeamMod::TeamOwner[%name] = "";
			$TeamMod::TeamCount[%name] = 0;
			
			messageAll('', "\c6The team \"\c3" @ %name @ "\c6\" has been disbanded");
		}
	}
}

function joinTeam(%c, %name)
{
	if(%c.team !$= %name)
	{
		%count = %c.banCount;
		
		while(%count > 0)
		{
			if(%c.bannedFromTeam[%count] $= %name && %name !$= "")
			{
				messageClient(%c, '', "\c6You are banned from this team");
				return;
			}
			%count--;
		}
				
		if(%name !$= "" && $TeamMod::Team[%name] !$= "")
		{
			if(%c.hasTeam)
			{
				leaveTeam(%c);
			}
			
			%clientCount = clientGroup.getCount();
			
			for(%i = 0; %i < %clientCount; %i++)
			{
				%client = clientGroup.getObject(%i);
					
				if(%client.team $= %name && %client != %c)
				{
					messageClient(%client, '', "\c3" @ %c.name SPC "\c6has joined the team");
				}
			}
				
			%c.team = %name;
				
			%c.hasTeam = 1;
			
			$TeamMod::TeamCount[%name]++;
			%c.inviter = "";
			messageClient(%c, '', "\c6You joined team \"\c3" @ %c.team @ "\c6\"");
		}
	}
}

function inviteToTeam(%c, %t)
{
	%t = findClientByName(%t);
	%name = %c.team;
	%count = %t.blockedInvitesCount;
	
	while(%count > 0)
	{
		if(%t.blockedInvites[%count] == %c)
		{
			messageClient(%c, '', "\c6That person has blocked your invitations");
			return;
		}
		%count--;
	}
	
	if(%c.hasTeam && %c.team !$= "" && isObject(%t) && %t != %c && %t.inviter $= "" && %t.inviter != %c)
	{
		messageClient(%c, '', "\c6Team invite sent to \c3" @ %t.name);
		
		messageClient(%t, '', "\c3" @ %c.name SPC "\c6has invited you to team \"\c3" @ %name @ "\c6\"");
		messageClient(%t, '', "\c6Type \c3/team accept \c6to accept the invite, type \c3/team reject \c6to reject the invite or type \c3/team block \c6to block the invite");
		
		%t.inviter = %c;
	}
}

function acceptTeamInvite(%c)
{
	if(%c.inviter.team !$= "" && $TeamMod::Team[%c.inviter.team] !$= "" && %c.inviter !$= "")
	{
		joinTeam(%c, %c.inviter.team);
		%c.inviter = "";
	}
}

function rejectTeamInvite(%c)
{
	if(%c.inviter !$= "")
	{
		messageClient(%c.inviter, '', "\c3" @ %c.name SPC "\c6rejected your invitation");
		messageClient(%c, '', "\c6Team invite rejected");
		%c.inviter = "";
	}
}

function blockTeamInvite(%c)
{
	if(%c.inviter !$= "")
	{
		messageClient(%c.inviter, '', "\c3" @ %c.name SPC "\c6has blocked invitations from you");
		messageClient(%c, '', "\c6Team invites blocked");
		
		%c.blockedInvitesCount++;
		%c.blockedInvites[%c.blockedInvitesCount] = %c.inviter;
		%c.inviter = "";
	}
}

function unblockTeamInvites(%c, %name)
{
	%name = findClientByName(%name);
	
	%count = %c.blockedInvitesCount;
	
	while(%count > 0)
	{
		if(%c.blockedInvites[%count] == %name && %name !$= "")
		{
			messageClient(%c, '', "\c6Team invites from \"\c3" @ %name.name @ "\c6\" unblocked");
			%c.blockedInvites[%count] = "";
		}
		%count--;
	}
}


function removeFromTeam(%c, %t)
{
	%t = findClientByName(%t);
	
	%name = %c.team;
	
	if(%t.team $= %c.team && $TeamMod::TeamOwner[%c.team] == %c && %t.hasTeam && %c != %t)
	{
		%t.team = "";
		%t.hasTeam = 0;
		
		$TeamMod::TeamCount[%name]--;
				
		messageClient(%t, '', "\c6You were removed from the team");
		messageClient(%c, '', "\c6You kicked \c3" @ %t.name SPC "\c6from the team");
		
		%clientCount = clientGroup.getCount();
		

		for(%i = 0; %i < %clientCount; %i++)
		{
			%client = clientGroup.getObject(%i);
				
			if(%client.team $= %name)
			{
				messageClient(%client, '', "\c3" @ %t.name SPC "\c6was kicked from the team");
			}
		}
	}
}

function banFromTeam(%c, %t)
{
	%t = findClientByName(%t);
	
	%name = %c.team;
	
	if($TeamMod::TeamOwner[%c.team] == %c && %c != %t)
	{
		%t.team = "";
		%t.hasTeam = 0;
		
		%t.banCount++;
		%t.bannedFromTeam[%t.banCount] = %c.team;
		
		$TeamMod::TeamCount[%name]--;
				
		messageClient(%t, '', "\c6You were banned from the team \"\c3" @ %c.team @ "\c6\"");
		messageClient(%c, '', "\c6You banned \c3" @ %t.name SPC "\c6from the team");
		
		%clientCount = clientGroup.getCount();
		

		for(%i = 0; %i < %clientCount; %i++)
		{
			%client = clientGroup.getObject(%i);
				
			if(%client.team $= %name)
			{
				messageClient(%client, '', "\c3" @ %t.name SPC "\c6was banned from the team");
			}
		}
	}
}

function unbanFromTeam(%c, %t)
{
	%t = findClientByName(%t);
	
	%name = %c.team;
	
	if($TeamMod::TeamOwner[%c.team] == %c && %c != %t)
	{
		%count = %t.banCount;
	
		while(%count > 0)
		{
			if(%t.bannedFromTeam[%count] $= %c.team)
			{
				%t.bannedFromTeam[%count] = "";
			}
			%count--;
		}
				
		messageClient(%t, '', "\c6You were unbanned from team \"\c3" @ %c.team @ "\c6\"");
		messageClient(%c, '', "\c6You unbanned \c3" @ %t.name SPC "\c6from the team");
		
		%clientCount = clientGroup.getCount();
		
		for(%i = 0; %i < %clientCount; %i++)
		{
			%client = clientGroup.getObject(%i);
				
			if(%client.team $= %name)
			{
				messageClient(%client, '', "\c3" @ %t.name SPC "\c6was unbanned from the team");
			}
		}
	}
}

function teamModHelp(%c)
{
	messageClient(%c, '', "\c7==== \c3Team Mod \c7 ====");
	messageClient(%c, '', "\c6Type \c3/team create teamName \c6to create a new team");
	messageClient(%c, '', "\c6Type \c3/team disband \c6to disband your team");
	messageClient(%c, '', "\c6Type \c3/team join teamName \c6to join a team");
	messageClient(%c, '', "\c6Type \c3/team leave \c6to leave a team");
	messageClient(%c, '', "\c6Type \c3/team kick playerName \c6to kick a player from your team");
	messageClient(%c, '', "\c6Type \c3/team ban playerName \c6to ban a player from your team");
	messageClient(%c, '', "\c6Type \c3/team unban playerName \c6to unban a player from your team");
	messageClient(%c, '', "\c6Type \c3/team invite playerName \c6to invite a player to join your team");
	messageClient(%c, '', "\c6Type \c3/team accept \c6to accept a team invite");
	messageClient(%c, '', "\c6Type \c3/team reject \c6to reject a team invite");
	messageClient(%c, '', "\c6Type \c3/team block \c6to block invitations from a player");
	messageClient(%c, '', "\c6Type \c3/team unblock playerName \c6to unblock invitations from a player");
	messageClient(%c, '', "\c6Type \c3/team help \c6to see this again");
	messageClient(%c, '', "\c6Press the \c2PageUp \c6key to view the rest of the commands");
}
